﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
#Event: Solved (Move as int)
#Event: Movement (Move as int)

#DesignerProperty: Key: Grid, DisplayName: Number Grid, FieldType: int, DefaultValue: 4, MinRange: 3, MaxRange: 6
#DesignerProperty: Key: Number, DisplayName: Draw Number, FieldType: Boolean, DefaultValue: False, Description: Draw Number of Tile

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Movement As Int = 0
	
	Private Cateto As Int = 6
	Private ImageViewMatrix(Cateto,Cateto) As B4XView
	Private ImageMatrix(Cateto*Cateto) As B4XBitmap
	Private Matrix(Cateto,Cateto) As Int
	Private Number As Boolean
	Private Active As Boolean = True
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	
	If Props.ContainsKey("Grid") Then Cateto=Props.Get("Grid")
	If Props.ContainsKey("Number") Then Number=Props.Get("Number")
	
	CreateTile
	If xui.IsB4A Then 
		Image_To_Matrix(mBase.Snapshot,True)
		mBase.Color=xui.Color_Black
		RandomImage
		Draw
	End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

public Sub setImageDrawable (Bmp As B4XBitmap)
	Image_To_Matrix(Bmp.Resize(mBase.Width,mBase.Height,False),True)
	RandomImage
	Draw
End Sub

Public Sub Solve
	For y=0 To Cateto-1
		For x=0 To Cateto-1
			Matrix(x,y)=x+y*Cateto
		Next
	Next
	Active=False
	Draw
End Sub

Public Sub ReMixPuzzle
	RandomImage
	Draw
End Sub

Public Sub getMovement As Int
	Return Movement
End Sub

Private Sub Image_To_Matrix(Btm As B4XBitmap,frame As Boolean )
	Dim Can As B4XCanvas
	Dim Width As Double = mBase.Width/Cateto
	Dim Height As Double = mBase.Height/Cateto
	
	For Y=0 To Cateto-1
		For X=0 To Cateto-1
			Log(y & "-" & X)
			ImageViewMatrix(X,Y).RemoveAllViews
			Can.Initialize(ImageViewMatrix(X,Y))
			Dim Rec As B4XRect
			Rec.Initialize(0,0,ImageViewMatrix(X,Y).Width,ImageViewMatrix(X,Y).Height)
			If (X=Cateto-1)And(Y=Cateto-1) Then 
				Can.DrawRect(Rec,xui.Color_Black,True,1dip)
			Else
				Can.DrawBitmap(Btm.Crop(X*Width,y*Height,Width,Height),Rec)
				If frame Then Can.DrawRect(Can.TargetRect,xui.Color_Black,False,1dip)
			End If
			
			If Number Then 
				Can.DrawText(((X + Y * Cateto)+1),Width/2,2*Height/3,xui.CreateDefaultBoldFont(Min(Width,Height)/(70dip/50)),xui.Color_Black,"CENTER" )
				Can.DrawText(((X + Y * Cateto)+1),Width/2,2*Height/3-1dip,xui.CreateDefaultBoldFont(Min(Width,Height)/(75dip/50)),xui.Color_White,"CENTER" )
			End If
			
			Can.Invalidate
			ImageMatrix(X + Y * Cateto)=ImageViewMatrix(X,y).Snapshot
		Next
	Next
	Can.Release
End Sub

Private Sub CreateTile
	
	For x=0 To Cateto-1
		For y=0 To Cateto-1
			ImageViewMatrix(x,y)=xui.CreatePanel("ImageViewMatrix")
			ImageViewMatrix(x,y).Tag=X & " " & y 
		Next
	Next
		
	Dim Width As Int = Floor(mBase.Width/Cateto)
	Dim Height As Int = Floor(mBase.Height/Cateto)
	For X=0 To Cateto-1
		For Y=0 To Cateto-1
			mBase.AddView(ImageViewMatrix(X,Y),X*Width,Y*Height,Width,Height)
		Next
	Next
End Sub

Private Sub RandomImage
	Dim X As Int = Cateto - 1
	Dim Y As Int = Cateto - 1
	Dim NewX,NewY As Int
	
	Movement=0
	Active=True
	For Xx=0 To Cateto-1
		For Yy=0 To Cateto-1
			Matrix(Xx,Yy)=Xx+Yy*Cateto
		Next
	Next
	
	For i= 1 To 100
		NewX=X
		NewY=y
		Do While Matrix(NewX,NewY)=Power(Cateto,2)-1
			If Rnd(0,2)=0 Then
				NewX=Rnd(Max(X-1,0),Min(Cateto,X+2))
				NewY=Y
			Else
				NewX=x
				NewY=Rnd(Max(y-1,0),Min(Cateto,y+2))
			End If
		Loop
		Matrix(X,Y)=Matrix(NewX,NewY)
		Matrix(NewX,NewY)=Power(Cateto,2)-1
		X=NewX
		Y=NewY
	Next
End Sub

Private Sub Draw
	For X=0 To Cateto-1
		For Y=0 To Cateto-1
			SetBitmap(ImageViewMatrix(X,Y),ImageMatrix(Matrix(X,Y)))
		Next
	Next
End Sub

Private Sub ImageViewMatrix_Click
	Dim IM As B4XView = Sender
	Dim Tag As String = IM.Tag
	Dim X As Int = Tag.SubString2(0,Tag.IndexOf(" "))
	Dim y As Int = Tag.SubString(Tag.IndexOf(" ")+1)
	
	If Active Then 
		If GetSpaceFree(X-1,y) Then 
			' shift left
			Xchange(X,y,X-1,y)
		Else If GetSpaceFree(X+1,y) Then
			' shift right
			Xchange(X,y,X+1,y)
		Else If GetSpaceFree(X,y-1) Then
			' shift up
			Xchange(X,y,X,y-1)
		Else If GetSpaceFree(X,y+1) Then
			' shift down
			Xchange(X,y,X,y+1)
		End If
		
		Verify
	End If
End Sub

Private Sub GetSpaceFree(X As Int, Y As Int) As Boolean
	Dim B As Boolean = False
	Dim V As Int
	If (X>-1 And X<Cateto)And(Y>-1 And Y<Cateto) Then 
		V=Matrix(X,Y)
		If V=Power(Cateto,2)-1 Then B=True
	End If
	Return b
End Sub

Private Sub Xchange(X1 As Int,Y1 As Int,X2 As Int ,Y2 As Int) 
	Dim Width As Double = mBase.Width/Cateto
	Dim Height As Double = mBase.Height/Cateto
	
	Dim A As Int = Matrix(X1,Y1)
	Matrix(X1,Y1)=Matrix(X2,Y2)
	Matrix(X2,Y2)=A
	
	ImageViewMatrix(X1,Y1).Left=X2*Width
	ImageViewMatrix(X1,Y1).top=Y2*Height
	SetBitmap(ImageViewMatrix(X1,Y1),ImageMatrix(Matrix(X1,Y1)))
	
	ImageViewMatrix(X2,Y2).Left=X1*Width
	ImageViewMatrix(X2,Y2).top=Y1*Height
	SetBitmap(ImageViewMatrix(X2,Y2),ImageMatrix(Matrix(X2,Y2)))
	
	ImageViewMatrix(X2,Y2).BringToFront
	ImageViewMatrix(X1,Y1).SetLayoutAnimated(300,X1*Width,Y1*Height,Width,Height)
	ImageViewMatrix(X2,Y2).SetLayoutAnimated(300,X2*Width,Y2*Height,Width,Height)
	
	Movement=Movement+1
	#IF B4I
	If SubExists(mCallBack,mEventName & "_Movement",1) Then CallSub2(mCallBack,mEventName & "_Movement", Movement)
	#ELSE
		If SubExists(mCallBack,mEventName & "_Movement") Then CallSub2(mCallBack,mEventName & "_Movement", Movement)
	#END IF
End Sub

Private Sub Verify
	Dim B As Boolean = True
	For Y=0 To Cateto-1
		For X=0 To Cateto-1
			If Matrix(X,Y)<>(X+Y*Cateto) Then B=False
		Next
	Next
	
	If b Then 
		Active=False
		#IF B4I
			If SubExists(mCallBack,mEventName & "_Solved",1) Then CallSub2(mCallBack,mEventName & "_Solved",Movement)
		#ELSE
			If SubExists(mCallBack,mEventName & "_Solved") Then CallSub2(mCallBack,mEventName & "_Solved",Movement)
		#End If
	End If
End Sub

Private Sub SetBitmap(V As B4XView, Image As B4XBitmap)
	Dim Can As B4XCanvas
	
	V.RemoveAllViews
	Can.Initialize(v)
	Can.DrawBitmap(Image,Can.TargetRect)
	Can.Invalidate
	Can.Release
End Sub